<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<%
  /**
   * You can change these following variables to match the correct information, if necessary.
   */
  final int MAX_DISPLAY_CHARACTERS = 60;
  final int MAX_RECIPIENT_DISPLAY_CHARACTERS = 80;

  final String MANAGED_OBJECT_STATUS_PREDICATE = "metropolis_managed_object_status";
  final String MANAGED_OBJECT_NAME_PREDICATE = "metropolis_managed_object_name";
  final String MANAGED_OBJECT_TYPE_PREDICATE = "metropolis_managed_object_type";
  final String ORIGINATING_CAUSE_DESCRIPTION_CONSISE_PREDICATE = "metropolis_originating_cause_description_concise";

  final HashMap<String, String> PREDICATE_LABEL_MAP = new HashMap<String, String>();
  PREDICATE_LABEL_MAP.put(MANAGED_OBJECT_STATUS_PREDICATE.toLowerCase(), "Managed Object Status");
  PREDICATE_LABEL_MAP.put(MANAGED_OBJECT_NAME_PREDICATE.toLowerCase(), "Managed Object Name");
  PREDICATE_LABEL_MAP.put(MANAGED_OBJECT_TYPE_PREDICATE.toLowerCase(), "Managed Object Type");
  PREDICATE_LABEL_MAP.put(ORIGINATING_CAUSE_DESCRIPTION_CONSISE_PREDICATE.toLowerCase(), "Originating Cause Description Consise");

  /**
  * Build up the rest of the information on this form
  */
  
  final String subId = (String)request.getParameter("subscriptionId");
  final boolean creatingSubscription = subId == null || "0".equals(subId);

  int tabCount = 4;
  if(creatingSubscription)
  {
    tabCount--;
  }
  if(subscriptionBean.isSelfSubscription())
  {
    tabCount--;
  }
  if(subscriptionBean.allOverridesSuppressed() && subscriptionBean.isTimeframeSuppressed())
  {
    tabCount--;
  }

  final HashMap<String, String> PREDICATE_SUMMARY_MAP = new HashMap<String, String>();
  Iterator<PredicateBeanImpl> summaryIter = subscriptionBean.getPredicateIterator();
  while(summaryIter.hasNext())
  {
    final PredicateBean predicate = summaryIter.next();
    String name = predicate.getPredicateName().toLowerCase();
    StringBuffer summary = new StringBuffer();
    if(!predicate.getSelectedValues().isEmpty())
    {
      if(predicate.hasAnySelectedValue())
      {
        summary.append("ANY");
      }
      else
      {
        Iterator<String> valIter = predicate.getSelectedValues().iterator();
        while(valIter.hasNext())
        {
          summary.append(valIter.next());
          if(valIter.hasNext())
            summary.append(", ");
          if(summary.length() > MAX_DISPLAY_CHARACTERS)
          {
            summary.setLength(MAX_DISPLAY_CHARACTERS);
            break;
          }
        }
      }
    }
    PREDICATE_SUMMARY_MAP.put(name, summary.toString());
  }
%>

<subscription-panel xmlns:fi="http://apache.org/cocoon/forms/1.0#instance"
                    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
                    onload="onLoad();"
                    onsubmit="return validateForm(this);" >

  <style media="screen" type="text/css">
    span.forms-tab {  	
      display: inline;
      position: relative;
      top: -1px;
      z-index: 1;
      overflow: hidden;
      font-weight: bold;    
      text-decoration: none;
      cursor: pointer;
      color: #333;    
      background: transparent url(/static/images/layout/main-menu-bg-off.gif) no-repeat top left;
      padding: 6px 7px 1px 11px;
      border-right: 1px solid #666;
      border-bottom: 1px solid #666;
      border-top: none;
      border-left: none;    
      margin: 0;
    }

    span.forms-tab:hover {  	
      background: transparent url(/static/images/layout/main-menu-bg-hover.gif) no-repeat top left;
    }

    span.forms-tab.forms-activeTab {
      display: inline;
      position: relative;
      top: 1px;
      z-index: 10;    
      overflow: hidden; 
      cursor: default;
      color: #990033;
      background: transparent url(/static/images/layout/main-menu-bg-selected.gif) no-repeat top left;
      padding: 7px 7px 1px 11px;
      border-bottom: none;
    }

    span.forms-tab.forms-activeTab:hover {
      background-color: #FFF;
      position: relative;
    }

    span.forms-tabContent {
      background-color: #FFF;
      border: 1px solid #666;
      /*padding: 3em;*/
      position: relative;
      z-index: 2;
    }

    #sandbag-01,
    #sandbag-02 {
      clear: left;
      float: left;
      padding: 0pt; /*border: 1px solid #0f0;*/
    }

    #sandbag-01 {
      height: 10px;
      width: 160px;
    }

    #sandbag-02 {
      height: 10px;
      width: 95px;
    }

    #refreshNodeButton, #refreshNodeGroupsButton {
      line-height: 18px;
      vertical-align: top;
    }

    #PREDICATE_VALUE_NODE, #PREDICATE_VALUE_NODE_GROUPS {
      width: 115px;
    }

    label#matching {
      font-weight: bold;
      width: 175px;
    }

    div.form-row label.summary {
      font-weight: bold;
      width: 0px;
      float: none;
      text-align: left;
      vertical-align: middle;
      padding: 0px 4px 0px 0px;
      margin-left: 85px;
    }

    span.summary-row {
      float: none;
      text-align: left;
      vertical-align: middle;
      padding: 0px 0px 0px 0px;
    }

    span.summary-row span.summary-item {
      float: none;
      padding: 0px 5px 0px 0px;
    }

    span.elipse {
      font-size: 11px;
      color: #0000CC;
      margin: 0px 0px 0px 5px;
      padding: 0;
      text-decoration: underline;
      background-color: transparent;
      border: none;
      cursor: pointer;
    }

    div.form-row ul#summary_list {
      margin-left: 100px;
      padding: 0px 0px 0px 0px;
    }

    div.form-row ul#summary_list li {
      display: list-item;
      padding: 0px 3px 0px 0px;
    }

    div.form-row ul#summary_list li.summary_AND {
      font-weight: bold;
      list-style: none;
      margin-left: 20px;
    }

    div.form-row ul#summary_list li.summary-item span.summary_text italic {
      font-style: italic;
    }
  </style>

  <script type="text/javascript" language="JavaScript">
    var old_forms_showTab;
    function onLoad()
    {
     old_forms_showTab = forms_showTab;
     forms_showTab = new_forms_showTab;
     var lastTab = document.DefaultSubscriptionForm.currentTab.value;
      if(window.location.hash == "#recipients")
        lastTab = 4;
     if(lastTab != null &amp;&amp; lastTab != "" &amp;&amp; lastTab != "null")
       forms_showTab("attributes", lastTab, 5, "");
    }
    
    function new_forms_showTab(tabgroup, idx, length, state)
    {
      document.DefaultSubscriptionForm.currentTab.value = idx;
      old_forms_showTab(tabgroup, idx, length, state);
    }
  </script>

  <input type="hidden" name="currentTab" value="<%=request.getParameter("currentTab")%>" /> 


  <text-widget id="name">
    <value><%= subscriptionBean.getName() %></value>
  </text-widget>

  <group label="Attributes">

    <tab-group id="attributes">

    <%
    if(!creatingSubscription)
    {
      %>
      <tab-content id="summary_tab" label="Summary">
        <div class="form-row">
          <label id="matching">Matching Any Event Where</label>
        </div>
        <div class="form-row">
          <ul id="summary_list">
          <%
          Iterator<PredicateBeanImpl> iterator = subscriptionBean.getPredicateIterator();
          boolean firstNonEmptyPredicate = true;
          while(iterator.hasNext())
          {
            final PredicateBean predicate = iterator.next();
            if(!predicate.getSelectedValues().isEmpty())
            {
              String name = predicate.getPredicateName().toLowerCase();
              if(!firstNonEmptyPredicate)
              {
                %>
                <li class="summary_AND">
                  <span class="summary_text">AND</span>
                </li>
                <%
              }
              %>
              <li class="summary-item">
                <%
                if(PREDICATE_LABEL_MAP.get(name.toLowerCase()) != null)
                {
                  %>
                  <span class="predicate_data"><%=PREDICATE_LABEL_MAP.get(name.toLowerCase())%></span>
                  <%
                }
                else
                {
                  %>
                  <span class="predicate_data"><%=name%></span>
                  <%
                }
                %>
                <span class="summary_text italic"> <%=predicate.getSelectedOperatorType()%></span>
                <span class="predicate_data">(<%=PREDICATE_SUMMARY_MAP.get(name)%></span>
                <%
                if(PREDICATE_SUMMARY_MAP.get(name).length() >= MAX_DISPLAY_CHARACTERS)
                {
                  %>
                  <span class="elipse" onclick="forms_showTab('attributes', 1, <%=Integer.toString(tabCount)%>, '')" >...</span>
                  <%
                }
                %>
                <span class="summary_text">)</span>
              </li>
              <%
              firstNonEmptyPredicate = false;
            }
          }
          %>
          </ul>
        </div>

        <div class="form-row">
          <label class="summary">Available:</label>
          <span class="summary-row">
            <%
            if(subscriptionBean.isOnSunday())
            {
              out.print("<span class=\"summary-item\">Sun</span>");
            }
            if(subscriptionBean.isOnMonday())
            {
              out.print("<span class=\"summary-item\">Mon</span>");
            }
            if(subscriptionBean.isOnTuesday())
            {
              out.print("<span class=\"summary-item\">Tue</span>");
            }
            if(subscriptionBean.isOnWednesday())
            {
              out.print("<span class=\"summary-item\">Wed</span>");
            }
            if(subscriptionBean.isOnThursday())
            {
              out.print("<span class=\"summary-item\">Thu</span>");
            }
            if(subscriptionBean.isOnFriday())
            {
              out.print("<span class=\"summary-item\">Fri</span>");
            }
            if(subscriptionBean.isOnSaturday())
            {
              out.print("<span class=\"summary-item\">Sat</span>");
            }
            %>

            <span class="summary-item"><%=subscriptionBean.getStartTime()%></span>
            <span class="summary-item">-</span>
            <span class="summary-item"><%=subscriptionBean.getEndTime()%></span>
          </span>
        </div>
        <div class="form-row">
          <label class="summary">Using:</label>
          <span class="summary-row">
            <%
            if(subscriptionBean.hasAllDeviceFilter())
            {
              out.print("<span class=\"summary-item\">All Devices</span>");
            }
            else
            {
              List<String> types = subscriptionBean.getDeviceTypeOverrides();
              for(String type : types)
              {
                %>
                <span class="summary-item"><%=type.substring(NotificationAPI.DEVICE_FILTER_FIELD_PREFIX.length())%></span>
                <%
              }
            }
            %>
          </span>
        </div>
        <%
        if(!subscriptionBean.isSelfSubscription())
        {
          %>
          <div class="form-row">
            <label class="summary">Targeting:</label>
            <span class="summary-row">
              <%
              int charactersDisplayed = 0;
              List<String> recipients = subscriptionBean.getRecipients();
              for(String recipient : recipients)
              {
                %>
                <span class="summary-item"><%=recipient%></span>
                <%
                charactersDisplayed += recipient.length();
                if(charactersDisplayed > MAX_RECIPIENT_DISPLAY_CHARACTERS)
                {
                  out.print("<span class=\"summary-item\">...</span>");
                  break;
                }
              }
              %>
            </span>
          </div>
          <%
        }
        %>
        </tab-content>
        <%
      }
      %>

      <tab-content id="attributes" label="Managed Object">
        <%
        for(PredicateBean predicate : subscriptionBean.getListPredicates()){
          String predicateName = predicate.getPredicateName();
          %>
          <div class="form-row">
            <%
            if(PREDICATE_LABEL_MAP.containsKey(predicateName.toLowerCase()))
            {
              %>
              <label class="widget" for="<%=predicate.getPredicateValueWidgetId()%>"><%=PREDICATE_LABEL_MAP.get(predicateName.toLowerCase())%>:</label>
              <% 
            }
            else
            { 
              %>
              <label class="widget" for="<%=predicate.getPredicateValueWidgetId()%>"><%=predicateName%>:</label>
              <%
            }
            %>
            <span  id="<%=predicate.getPredicateValueWidgetId()%>">
              <%
              Collection<String> selectedValues = predicate.getSelectedValues();
              Collection<String> values = predicate.getPredicateValues();
              %>
              <select size="5" multiple="0" id="<%=predicate.getPredicateValueWidgetId()%>" name="<%=predicate.getPredicateValueWidgetId()%>" >
                <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedValues.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
                <%
                for (String value : values)
                {
                  %>
                  <option value="<%=value%>" <% if(selectedValues.contains(value))out.print("selected=\"true\""); %> ><%=value%></option>
                  <%
                }
                %>
              </select>
            </span>
          </div>
          <%
        }
        if(!subscriptionBean.getTextPredicates().isEmpty())
        {
          %>
          <list-table type="input-table">
            <list-table-column-header label="Name" i18n:attr="label" />
            <list-table-column-header label="Operator" i18n:attr="label" />
            <list-table-column-header label="Value" i18n:attr="label" />
          <%
          for(PredicateBean predicate : subscriptionBean.getTextPredicates()){
            String predicateName = predicate.getPredicateName();
              %>
              <list-table-row>
                <% 
                if(PREDICATE_LABEL_MAP.containsKey(predicateName.toLowerCase()))
                { 
                  %>
                  <list-table-row-item type="value" value="<%=PREDICATE_LABEL_MAP.get(predicateName.toLowerCase())%>"/>
                  <% 
                }
                else
                {
                  %>
                  <list-table-row-item type="value" value="<%=predicateName%>"/>
                  <% 
                }
                %>
                <list-table-row-item type="template">
                  <select id="<%=predicate.getOperatorWidgetId()%>" name="<%=predicate.getOperatorWidgetId()%>">
                    <%
                    for(String operatorType : subscriptionBean.getValidOperatorTypeValues())
                    {
                      %>
                      <option value="<%=operatorType%>" <% if(predicate.getSelectedOperatorType().equals(operatorType))out.print("selected=\"true\""); %>><i18n:text><%=operatorType%></i18n:text></option>
                      <%
                    }
                    %>
                  </select>
                </list-table-row-item>
                <list-table-row-item type="template">
                  <input id="<%=predicate.getPredicateValueWidgetId()%>" name="<%=predicate.getPredicateValueWidgetId()%>" value="<%=predicate.getSelectedValue()%>" maxlength="800"/>
                </list-table-row-item>
              </list-table-row>
              <%
          }
          %>
        </list-table>
        <%
        }
        %>
      </tab-content>

      <%
      if(!subscriptionBean.allOverridesSuppressed() || !subscriptionBean.isTimeframeSuppressed())
      {
        %>
        <tab-content id="pref_tab" label="Preferences">
          <subscription-timeframe group-label="Timeframe" />
          <subscription-overrides group-label="Overrides" />
        </tab-content>
        <%
      }
      %>

      <%
      if(!subscriptionBean.isSelfSubscription())
      {
        %>
        <tab-content id="assigned_tab" label="Assign">
          <subscribed-recipients group-label="Recipients" />
        </tab-content>
        <%
      }
      %>
    </tab-group>
  </group>

</subscription-panel>
